function result=CostFunc(X1,X2,choice)

switch choice
    case 1,
%  Example:
%     The so-called "six-hump camelback" function has several local minima 
%     in the range -3<=x<=3 and -2<=y<=2. It has two global minima, namely
%     f(-0.0898,0.7126) = f(0.0898,-0.7126) = -1.0316. 
%     We get output:
%               x =
%                  -0.0899    0.7127
%               f =
%                  -1.0316
%     Which reasonably approximates the analytical global minimum (note
%     that due to randomness, your results will likely not be exactly the
%     same).

  Width=length(X1);
  Height=length(X2);
  Z(1:Width, 1:Height)=0;

  for w=1:Width
      for h=1:Height
         Z(w,h)=(4-2.1*X1(w)^2 + X1(w)^4/3).*X1(w)^2 + X1(w)*X2(h) + 4*(X2(h)^2-1).*X2(h)^2;
      end;
  end;
 result=Z;
    case 2, % Potential function
        A1=13;      B1=3;    C1=1;
        A2=5;      B2=2.5;  C2=3;
        A3=7;      B3=1;    C3=2;
        A4=10;    B4=2;    C4=3;
        
        f1=-A1*exp( -B1*(abs( (X1-C1).^1.5 ) + abs(X2.^1.5)) );
        f2=-A2*exp( -B2*(abs((X1+C2).^2.5) + abs(X2.^2.5)) );
        f3=-A3*exp( -B3*(abs(X1.^1.2) + abs((X2-C3).^1.2)) );
        f4=-A4*exp( -B4*(abs(X1.^2) + abs((X2+C4).^2)) );

        [n,m]=size(f1);
        F(1:n, 1:m, 1:4)=0;
        F(:,:,1)=f1;
        F(:,:,2)=f2;
        F(:,:,3)=f3;
        F(:,:,4)=f4;
        result=min(F,[], 3);  
        
     case 3,   % Himmelblau function
         Width=length(X1);
         Height=length(X2);
         Z(1:Width, 1:Height)=0;

         for w=1:Width
           for h=1:Height
            Z(w,h)=(X1(w)^2 + X2(h) - 11)^2 + (X1(w) + X2(h)^2 - 7)^2;
           end;
         end;
     result=Z;  
     
    case 4,  % Rosenbrock function
        result=100*(X2 - X1.^2).^2 + (1-X1).^2;
        
    case 5, 
        result=-(1 + 8*X1 - 7*X1.^2 + 7/3*X1.^3 - 0.25*X1.^4).*(X2.^2)*exp(-X2);
    case 6, 
       % result=(X1.^2 + X2.^2)/100 - (cos(X1)+cos(X2))/sqrt(2)+2;
        result=(X1.^2 + X2.^2)/100 - (cos(X1)+cos(X2));
      %  result=(X1 + X2).^2 -100*(cos(X1)+sin(X2));
        
end;

