
function [NUCLEI_SINGLED] = ImageProcessing(I)

[len_x len_y len_c] = size(I);

'finds tumor mask'
[TUMOR MinDiameter MaxDiameter BW_3] = tumormask_holes_tumor(I);

MaxArea = pi*(0.5*MaxDiameter)^2; 
D = bwdist(BW_3);
DL = watershed(D);
bgm = DL == 0;
bgm = ~bgm;
bgm = and(TUMOR,bgm);
[B_REGION,L_REGION] = bwboundaries(bgm,'noholes');
stats = regionprops(L_REGION,'PixelIdxList');
BLUE = I(:,:,3);
NUCLEI = logical(zeros(len_x, len_y));
for i=1:length(B_REGION)
    pixels = [];
    pixels = stats(i).PixelIdxList;
    array = [];
    array = BLUE(pixels(:));
    threshold = graythresh(array);
  
    indexes = [];
    indexes = find(array>threshold);
    NUCLEI(pixels(indexes(:))) = 1;
end

se = strel('disk', 2);
NUCLEI = imdilate(NUCLEI,se);
NUCLEI = imerode(NUCLEI,se);
NUCLEI = imfill(NUCLEI,'holes');
[B,L] = bwboundaries(NUCLEI,'noholes');


stats = regionprops(L,'Area','PixelIdxList','EquivDiameter');
NUCLEI_CLUMPED = NUCLEI;
NUCLEI_CLUMPED(:,:) = 0;
NUCLEI_SINGLED= NUCLEI;
for i=1:length(B)
    if stats(i).Area>MaxArea
        NUCLEI_CLUMPED(stats(i).PixelIdxList) = 1;
        NUCLEI_SINGLED(stats(i).PixelIdxList) = 0;
    end
end

[B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_CLUMPED,'noholes');
stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList');
    
NUCLEI3 = NUCLEI_CLUMPED;
se = strel('disk', 2);
NUCLEI3 = imerode(NUCLEI3,se);
k = 0;
while sum(NUCLEI3(:))>0
    k = k+1
    WatershedBoundaries = []; BLUE_2 = []; Overlaid = [];
    BLUE_2 = bwdist(~NUCLEI_CLUMPED);
    Overlaid = imimposemin(1-BLUE_2,NUCLEI3);
    WatershedBoundaries = watershed(Overlaid) > 0;
    NUCLEI_CLUMPED = NUCLEI_CLUMPED.*WatershedBoundaries; 
    
    B_CLUMPED = []; L_CLUMPED = []; stats_clumped = [];
    [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_CLUMPED,'noholes');
    stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList');
    
    for j=1:length(B_CLUMPED)
        if stats_clumped(j).Area<MaxArea
            NUCLEI_SINGLED(stats_clumped(j).PixelIdxList) = 1;
            NUCLEI_CLUMPED(stats_clumped(j).PixelIdxList) = 0;
        end
    end
    NUCLEI3 = imerode(NUCLEI3,se);
    
end


NUCLEI_SINGLED2 = NUCLEI_SINGLED;
NUCLEI_SINGLED = NUCLEI_SINGLED2;

B_CLUMPED = []; L_CLUMPED = []; stats_clumped = [];
[B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_SINGLED,'noholes');
stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList','Perimeter');
AREA = [];
 for j=1:length(B_CLUMPED)
     AREA(j) = (stats_clumped(j).Perimeter^2)/stats_clumped(j).Area;
 end
 threshold = max(AREA)*graythresh(AREA/max(AREA));
 
 indexes = [];
 NUCLEI_CLUMPED = NUCLEI_SINGLED;
 NUCLEI_CLUMPED(:,:) = 0;
 indexes = find(AREA>threshold);
 for i=1:length(indexes)
     pixels = [];
     pixels = stats_clumped(indexes(i)).PixelIdxList;
     NUCLEI_CLUMPED(pixels) = 1;
     NUCLEI_SINGLED(pixels) = 0;
 end
 BLUE_2  = bwdist(~NUCLEI_CLUMPED);
 
 [CENTERS] = CenterOfCells(BLUE_2,MinDiameter,MaxDiameter,1);
 Overlaid = imimposemin(1-BLUE_2,CENTERS);
 WatershedBoundaries = watershed(Overlaid) == 0;
 NUCLEI_CLUMPED = NUCLEI_CLUMPED.*(~WatershedBoundaries); 
 NUCLEI_SINGLED  = or(NUCLEI_CLUMPED,NUCLEI_SINGLED);
 NUCLEI_SINGLED = bwareaopen(NUCLEI_SINGLED,fix(0.25*pi*MinDiameter^2));
D = bwdist(NUCLEI_SINGLED);
DL = watershed(D);
bgm = DL == 0;
bgm = ~bgm;
bgm = and(TUMOR,bgm);

[B_CELL,L_CELL] = bwboundaries(bgm,'noholes');
[B_NUCLEI,L_NUCLEI] = bwboundaries(NUCLEI_SINGLED,'noholes');
% 27.09 v 8.00 v 9.30 v 310 na revolucionnoi