function [mat, mat2, Z] = LisitsaPCA(I)
% split channels of image
[R G B] = ColorToGray(I);
% we use only green channel to determine the grayscale image,
% becuae cells contain the stains, which is green
[len_x len_y len_z] = size(I);
RED = I(:,:,1);
GREEN = I(:,:,2);
BLUE = I(:,:,3);
array = [];
array = BLUE(1:len_x*len_y);
LENGTH = length(array);
X = zeros(LENGTH, 6);
X_ = zeros(LENGTH, 6);

array(1:LENGTH)= array;
X(:,1) = array+1; % intensity in blue channel
array(1:LENGTH)= GREEN(1:len_x*len_y);
X(:,2) = array+1; % intensity in green channel
X(:,3) = X(:,1)./X(:,2);
X(:,4) = X(:,2)./X(:,1);
X(:,5) = 1./X(:,1);
X(:,6) = 1./X(:,2);

MEAN = mean(X);
STD = std(X);
for j=1:6
    X_(:,j) = (X(:,j) - MEAN(j))/STD(j);
end

R = X_'*X_/(LENGTH-1);
[A L] = eig(R);
weight = diag(L)/sum(sum(L));
Z = X_*A;
MEAN2 = mean(Z);
STD2 = std(Z);
for j=1:6
    Z_(:,j) = ((Z(:,j) - MEAN2(j))/STD2(j)+3)/6;
end
mat = vec2mat(Z_(:,6),	len_x);
mat2 = vec2mat(Z_(:,5),	len_x);
