function [Z,ContribLamb] = PCAFunction(RAW_DATA)
[len_x len_y len_z] = size(RAW_DATA);

MEAN = mean(RAW_DATA);
STD = std(RAW_DATA);

for i=1:(len_y)
    NORM_DATA(:,i)=(RAW_DATA(:,i)-MEAN(i))/STD(i);
end
[N K] = size(NORM_DATA); 
%Calculating the correlation matrix.
XX = NORM_DATA;
R = (XX'*XX)/(N-1);
%Calculating the eigen values and eigen vectors (transormation) from the R-matrix.
[A,LAMB] = eig(R);

%Calculating the z-projections of the objects  
Z = XX*A;

%Calculating the covariance matrix  
CovZ = (Z'*Z)/(N-1);

%Calculating dispersion of the z-componet.
for i=1:K
  MStdZ(i) = std(Z(:,i));
  MStdX(i) = std(XX(:,i));
end

%Control of dispersions. They must be equal!
SumDispZ = sum(MStdZ.^2);
SumDispX = sum(MStdX.^2);

%Estimating the contributions of the principal components.
ContribZ = 100*MStdZ.^2/SumDispZ;
SUM = sum(ContribZ);
% NORM_ContribZ = ContribZ/SUM
L = eig(R);
ContribLamb = 100*L/sum(L);

[max_std number_std]= max(MStdZ);
