function [RESULT_2,GOOD_OBJECTS, BAD_OBJECTS_4, AREA, ROUGHNESS] = PostProcessing(IMAGE,RESULT,MaxDiameter,MinDiameter)

GOOD_OBJECTS = RESULT;
BAD_OBJECTS = RESULT; BAD_OBJECTS(:,:)=0;

 B = []; L = []; stats= [];
 [B,L] = bwboundaries(RESULT,'noholes');
 stats = regionprops(L,'Area','PixelIdxList','Perimeter','MajorAxisLength','MinorAxisLength');
 AREA = [];
 
 for j=1:length(B)
     ROUGHNESS(j) = stats(j).Area/(4*pi*stats(j).MajorAxisLength*stats(j).MajorAxisLength);
     AREA(j) = stats(j).Area;
 end
 
 indexes = find(ROUGHNESS==Inf);
 for j=1:length(indexes)
     pixels = [];
     pixels = stats(indexes(j)).PixelIdxList;
     GOOD_OBJECTS(pixels) = 0;
     BAD_OBJECTS(pixels) = 1;
 end
 
 B = []; L = []; stats= [];
 [B,L] = bwboundaries(GOOD_OBJECTS,'noholes');
 stats = regionprops(L,'Area','PixelIdxList','Perimeter','MajorAxisLength','MinorAxisLength','ConvexImage','Centroid','FilledImage');
 AREA = [];
 ROUGHNESS = [];
 for j=1:length(B)
     ROUGHNESS(j) = my_criteria(stats(j).FilledImage);
     AREA(j) = stats(j).Area/stats(j).Perimeter;
 end
 NORM_AREA = normalization(AREA);
 NORM_ROUGHNESS = normalization(ROUGHNESS);

indexes =  find(AREA~=Inf);
threshold_area = max(AREA(indexes))*graythresh(AREA(indexes)/max(AREA(indexes)));
threshold_roughness = max(ROUGHNESS)*graythresh(ROUGHNESS/max(ROUGHNESS)); 
T = ones(1,length(AREA));
indexes_area = find(AREA<threshold_area);
T(indexes_area)=T(indexes_area)+1;
indexes_roughness = find(ROUGHNESS<threshold_roughness);
T(indexes_roughness)=T(indexes_roughness)+2;

GOOD_OBJECTS = GOOD_OBJECTS;
BAD_OBJECTS = GOOD_OBJECTS;
for i=1:length(B)
    if T(i)==1
        BAD_OBJECTS(stats(i).PixelIdxList) = 0;
    else
        GOOD_OBJECTS(stats(i).PixelIdxList) = 0;
    end
end

se = strel('disk',fix(MinDiameter));
se2 = strel('disk',2);
BAD_OBJECTS_2 = imclose(BAD_OBJECTS,se);
BAD_OBJECTS_2 = imfill(BAD_OBJECTS_2,'holes');
BAD_OBJECTS_3 = bwareaopen(BAD_OBJECTS_2,fix(0.25*pi*MinDiameter*MinDiameter));

AND = and(imdilate(GOOD_OBJECTS,se2),BAD_OBJECTS_3);
AND = imdilate(AND,se2);
BAD_OBJECTS_4 = BAD_OBJECTS_3;
BAD_OBJECTS_4(AND==1) = 0;
BAD_OBJECTS_4 = bwareaopen(BAD_OBJECTS_4,fix(0.25*pi*MinDiameter*MinDiameter));
BAD_OBJECTS_4 = imfill(BAD_OBJECTS_4,'holes');
RESULT_2 = or(BAD_OBJECTS_4,GOOD_OBJECTS);