function NUCLEI = creatrawmask(IMAGE,TUMOR,BW_3,MaxDiameter,MinDiameter)
MaxArea = pi*(0.5*MaxDiameter)^2; 
% addaptive thresholding of the image
    D = bwdist(BW_3);
    DL = watershed(D);
    bgm = DL == 0;
    bgm = ~bgm;
    bgm = and(TUMOR,bgm);
   
    [B_REGION,L_REGION] = bwboundaries(bgm,'noholes');
    stats = regionprops(L_REGION,'PixelIdxList');
    h = fspecial('gaussian',fix(MinDiameter),max([fix(MinDiameter/6),1]));
    BLUE_2 = imfilter(IMAGE(:,:,3),h);
    BLUE = im2double(IMAGE(:,:,3));
    [len_x, len_y, len_z] = size(IMAGE);
    NUCLEI = logical(zeros(len_x, len_y));
    for i=1:length(B_REGION)
        pixels = [];
        pixels = stats(i).PixelIdxList;
        array = [];
        array = BLUE(pixels(:));
        threshold = graythresh(array);
        array_2 = [];
        array_2 = BLUE_2(pixels(:));
       
        indexes = [];
        indexes = find(array_2>threshold);
        NUCLEI(pixels(indexes(:))) = 1;
    end
    
    se = strel('disk', 2);
    NUCLEI = imdilate(NUCLEI,se);
    NUCLEI = imerode(NUCLEI,se);
    NUCLEI = imfill(NUCLEI,'holes');