function [NUCLEI_SINGLED,NUCLEI_CLUMPED] = devideobjects1(IMAGE,NUCLEI,MaxDiameter,MinDiameter)   
MaxArea = pi*(0.5*MaxDiameter)^2;     
[B,L] = bwboundaries(NUCLEI,'noholes');
    stats = regionprops(L,'Area','PixelIdxList','EquivDiameter');
    NUCLEI_CLUMPED = NUCLEI;
    NUCLEI_CLUMPED(:,:) = 0;
    NUCLEI_SINGLED= NUCLEI;
    
    for i=1:length(B)
        if stats(i).Area>MaxArea
            NUCLEI_CLUMPED(stats(i).PixelIdxList) = 1;
            NUCLEI_SINGLED(stats(i).PixelIdxList) = 0;
        end
    end
    NUCLEI_SINGLED = bwareaopen(NUCLEI_SINGLED,fix(0.25*pi*MinDiameter^2));
    [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_CLUMPED,'noholes');
    stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList');
   
    NUCLEI3 = NUCLEI_CLUMPED;
    se = strel('disk', 2);
    NUCLEI3 = imerode(NUCLEI3,se);
 
%     makes devision of clumped cells only for the clumped objects
    k = 0;
    MAX = sum(NUCLEI3(:));
    while MAX>MaxArea
        k = k+1;
        WatershedBoundaries = []; BLUE_2 = []; Overlaid = [];
        BLUE_2 = IMAGE(:,:,3);
        Overlaid = imimposemin(1-BLUE_2,NUCLEI3);
        WatershedBoundaries = watershed(Overlaid) > 0;
        NUCLEI_CLUMPED = NUCLEI_CLUMPED.*WatershedBoundaries;
        B_CLUMPED = []; L_CLUMPED = []; stats_clumped = [];
        [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_CLUMPED,'noholes');
        stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList');
    
        for j=1:length(B_CLUMPED)
            if stats_clumped(j).Area<MaxArea
                NUCLEI_SINGLED(stats_clumped(j).PixelIdxList) = 1;
                NUCLEI_CLUMPED(stats_clumped(j).PixelIdxList) = 0;
            end
        end
        NUCLEI3 = imerode(NUCLEI3,se);    
        [B_NUCLEI3 L_NUCLEI3] = bwboundaries(NUCLEI3,'noholes');
        stats_NUCLEI3 = regionprops(L_NUCLEI3,'Area');
        AREA_L_NUCLEI3 = [];
        for f=1:length(B_NUCLEI3)
            AREA_L_NUCLEI3(f) = stats_NUCLEI3(f).Area;
        end
        MAX = max(AREA_L_NUCLEI3);   
    end