function [NUCLEI_SINGLED,AREA] = nuclei_segmentation1(IMAGE,TUMOR,MinDiameter,MaxDiameter,BW_3)

MaxArea = pi*(0.5*MaxDiameter)^2; 
% addaptive thresholding of the image
    D = bwdist(BW_3);
    DL = watershed(D);
    bgm = DL == 0;
    bgm = ~bgm;
    bgm = and(TUMOR,bgm);
   
    [B_REGION,L_REGION] = bwboundaries(bgm,'noholes');
    stats = regionprops(L_REGION,'PixelIdxList');
    h = fspecial('gaussian',fix(MaxDiameter),fix(MaxDiameter/6));
    BLUE_2 = imfilter(IMAGE(:,:,3),h);
    BLUE = IMAGE(:,:,3);
    [len_x, len_y, len_z] = size(IMAGE);
    NUCLEI = logical(zeros(len_x, len_y));
    for i=1:length(B_REGION)
        pixels = [];
        pixels = stats(i).PixelIdxList;
        array = [];
        array = BLUE(pixels(:));
        array_2 = [];
        array_2 = BLUE_2(pixels(:));
        threshold = graythresh(array);
%         threshold = Otsu(array);
        indexes = [];
        indexes = find(array>threshold);
        NUCLEI(pixels(indexes(:))) = 1;
    end
    
    se = strel('disk', 1);
    NUCLEI = imdilate(NUCLEI,se);
%     NUCLEI = imerode(NUCLEI,se);
    NUCLEI = imfill(NUCLEI,'holes');
    [B,L] = bwboundaries(NUCLEI,'noholes');
    imwrite(NUCLEI,['raw_nuclei.tif'])
figure(1),imshow(NUCLEI);
AREA = [];
% % makes two masks of the nuclei. The first mask contains the normal objects. The second mask is used for the clumped objects    
    stats = regionprops(L,'Area','PixelIdxList','EquivDiameter');
    NUCLEI_CLUMPED = NUCLEI;
    NUCLEI_CLUMPED(:,:) = 0;
    NUCLEI_SINGLED= NUCLEI;
%     threshold = MaxArea;
    threshold = 0.25*pi*MinDiameter*MinDiameter+MaxArea;
    for i=1:length(B)
        if stats(i).Area>threshold
            NUCLEI_CLUMPED(stats(i).PixelIdxList) = 1;
            NUCLEI_SINGLED(stats(i).PixelIdxList) = 0;
        end
    end
    NUCLEI_SINGLED = bwareaopen(NUCLEI_SINGLED,fix(0.25*pi*MinDiameter^2));

    [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_CLUMPED,'noholes');
    stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList');
   
    NUCLEI3 = NUCLEI_CLUMPED;
    se = strel('disk', 2);
    NUCLEI3 = imerode(NUCLEI3,se);
   

% %     makes devision of clumped cells only for the clumped objects
    k = 0;
    MAX = sum(NUCLEI3(:));
    S = 1;
    S_2 = 0;
   %         BLUE_2 = bwdist(~NUCLEI_CLUMPED);
        BLUE_2 = IMAGE(:,:,3);
%         BLUE_2 = imfilter(IMAGE(:,:,3),h);
      figure(3),imshow(NUCLEI_CLUMPED);     
    while abs(S-S_2)>0
        k = k+1;
        S_2 = sum(sum(NUCLEI_CLUMPED(:,:,:)));
        WatershedBoundaries = []; Overlaid = [];
        Overlaid = imimposemin(1-BLUE_2,NUCLEI3);
        WatershedBoundaries = watershed(Overlaid) > 0;
        NUCLEI_CLUMPED = NUCLEI_CLUMPED.*WatershedBoundaries;
        B_CLUMPED = []; L_CLUMPED = []; stats_clumped = [];
        [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_CLUMPED,'noholes');
        stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList');
    
        for j=1:length(B_CLUMPED)
            if stats_clumped(j).Area<threshold
                NUCLEI_SINGLED(stats_clumped(j).PixelIdxList) = 1;
                NUCLEI_CLUMPED(stats_clumped(j).PixelIdxList) = 0;
            end
        end
        NUCLEI3 = imerode(NUCLEI3,se);    
        [B_NUCLEI3 L_NUCLEI3] = bwboundaries(NUCLEI3,'noholes');
        stats_NUCLEI3 = regionprops(L_NUCLEI3,'Area');
        AREA_L_NUCLEI3 = [];
        for f=1:length(B_NUCLEI3)
            AREA_L_NUCLEI3(f) = stats_NUCLEI3(f).Area;
        end
        MAX = max(AREA_L_NUCLEI3);     
        S = sum(sum(NUCLEI_CLUMPED(:,:,:)));
        NUCLEI_CLUMPED = imfill(NUCLEI_CLUMPED,'holes');
%          figure,imshow(NUCLEI_CLUMPED)
    end
    NUCLEI_SINGLED = or(NUCLEI_CLUMPED,NUCLEI_SINGLED);
    NUCLEI_SINGLED = imfill(NUCLEI_SINGLED,'holes');
%     figure(2),imshow(NUCLEI_SINGLED);
 
% 
    B_CLUMPED = []; L_CLUMPED = []; stats_clumped = [];
    [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_SINGLED,'noholes');
    stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList','Perimeter');
    AREA = [];
    RATIO = [];
    LENGTH_B_CLUMPED = length(B_CLUMPED)
    for j=1:length(B_CLUMPED)
        RATIO(j) = 4*pi*stats_clumped(j).Area/(stats_clumped(j).Perimeter*stats_clumped(j).Perimeter);
        AREA(j) = stats_clumped(j).Area;
    end
    indexes = [];
    indexes = find(RATIO~=Inf);
    threshold = mean(RATIO(indexes))
    threshold = max(RATIO(indexes))*graythresh(RATIO(indexes));
%     threshold = MaxArea;
% &(stats_clumped(j).Area>mean(AREA))
    threshold = 3*0.25*pi*MinDiameter*MinDiameter;

    for i=1:length(B_CLUMPED)
        if (AREA(i)>threshold)
            NUCLEI_CLUMPED(stats_clumped(i).PixelIdxList) = 1;
            NUCLEI_SINGLED(stats_clumped(i).PixelIdxList) = 0;
        end
    end

%     figure(3),imshow(NUCLEI_CLUMPED);
%     BLUE_2  = bwdist(~NUCLEI_CLUMPED);
% 
%     NUCLEI_CLUMPED = voronoi_segmentation(BLUE_2,NUCLEI_CLUMPED,MinDiameter,MaxDiameter);     
%     
%    B_CLUMPED = []; L_CLUMPED = []; stats_clumped = [];
%     [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_CLUMPED,'noholes');
%     stats_clumped = regionprops(L_CLUMPED,'Area');
%     AREA = [];
%     LENGTH_B_CLUMPED = length(B_CLUMPED)
%     for j=1:length(B_CLUMPED)
%         AREA(j) = stats_clumped(j).Area;
%     end
%     threshold = fix(max(AREA)*graythresh(AREA/max(AREA)));
%     NUCLEI_CLUMPED = bwareaopen(NUCLEI_CLUMPED,threshold);
%     figure(2),hist(AREA,10);
% % figure(2),hist(AREA,10);
% 
%    NUCLEI_SINGLED = or(NUCLEI_CLUMPED,NUCLEI_SINGLED);
%


%        B_CLUMPED = []; L_CLUMPED = []; stats_clumped = [];
%     [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_SINGLED,'noholes');
%     stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList','Perimeter');
%     AREA = [];
%     RATIO = [];
%     LENGTH_B_CLUMPED = length(B_CLUMPED)
%     for j=1:length(B_CLUMPED)
%         RATIO(j) = 4*pi*stats_clumped(j).Area/(stats_clumped(j).Perimeter*stats_clumped(j).Perimeter);
%         AREA(j) = stats_clumped(j).Area;
%     end
%     indexes = [];
%     indexes = find(RATIO~=Inf);
%     threshold = mean(RATIO(indexes))
% %     threshold = MaxArea;
% % &(stats_clumped(j).Area>mean(AREA))
%     for i=1:length(B_CLUMPED)
%         if (RATIO(i)<threshold)
%             NUCLEI_CLUMPED(stats_clumped(i).PixelIdxList) = 1;
%             NUCLEI_SINGLED(stats_clumped(i).PixelIdxList) = 0;
%         end
%     end
%         
%     BLUE_2  = IMAGE(:,:,3);
%     NUCLEI_CLUMPED = voronoi_segmentation(BLUE_2,NUCLEI_CLUMPED,MinDiameter,MaxDiameter);     
%    figure(2),imshow(NUCLEI_SINGLED);
%    figure(3),imshow(NUCLEI_CLUMPED);
   NUCLEI_SINGLED = or(NUCLEI_CLUMPED,NUCLEI_SINGLED);
%   
   threshold = fix(0.25*pi*MinDiameter*MinDiameter);
   NUCLEI_SINGLED = and(NUCLEI_SINGLED,TUMOR);
   NUCLEI_SINGLED = bwareaopen(NUCLEI_SINGLED,threshold);
%    figure(4),imshow(NUCLEI_SINGLED);

   
     
   
   %   
%     NUCLEI_SINGLED  = or(NUCLEI_CLUMPED,NUCLEI_SINGLED);
%     
%      figure(2),imshow(NUCLEI_CLUMPED),title('NUCLEI_CLUMPED');
%     B_CLUMPED = []; L_CLUMPED = []; stats_clumped = [];
%     [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_CLUMPED,'noholes');
%     stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList','Perimeter');
%     AREA = [];
%     NUCLEI_CLUMPED(:,:) = 0;
%     for j=1:length(B_CLUMPED)
%         AREA(j) = stats_clumped(j).Area;
%     end
%     threshold = max(AREA)*graythresh((AREA)/max(AREA));
%     threshold = MaxArea;
%     for i=1:length(B_CLUMPED)
%         if AREA(i)>threshold
%             NUCLEI_CLUMPED(stats_clumped(i).PixelIdxList) = 1;
%             NUCLEI_SINGLED(stats_clumped(i).PixelIdxList) = 0;
%         end
%     end
% 
% %     BLUE_2 = im2double(IMAGE(:,:,3));
%      h = fspecial('gaussian',fix(MinDiameter),fix(MinDiameter/6));
%     BLUE_2 = imfilter(im2double(IMAGE(:,:,3)),h);
%      NUCLEI_CLUMPED = voronoi_segmentation(BLUE_2,NUCLEI_CLUMPED,MinDiameter,MaxDiameter);  
%    figure(3),imshow(NUCLEI_CLUMPED),title('NUCLEI_CLUMPED');
%    figure(4),imshow(NUCLEI_SINGLED),title('NUCLEI_SINGLED');
%     
%     NUCLEI_SINGLED  = or(NUCLEI_CLUMPED,NUCLEI_SINGLED);
%     
%      B_CLUMPED = []; L_CLUMPED = []; stats_clumped = [];
%     [B_CLUMPED,L_CLUMPED] = bwboundaries(NUCLEI_SINGLED,'noholes');
%     stats_clumped = regionprops(L_CLUMPED,'Area','PixelIdxList','Perimeter');
%     AREA = [];
%     for i=1:length(B_CLUMPED)
%         AREA(i) = stats_clumped(i).Area;
%     end
%     
% %     threshold = fix(max(AREA)*graythresh(AREA/max(AREA)));
%     threshold = fix(0.25*pi*MinDiameter*MinDiameter);
%     NUCLEI_SINGLED = bwareaopen(NUCLEI_SINGLED,threshold);