function NUCLEI = separate2(RESULT_ERODE,IMAGE,MIN_DIAMETER,MAX_DIAMETER)
IMAGE = im2double(IMAGE);  
BLUE = IMAGE(:,:,3);

MaxArea = 2*pi*(0.5*MAX_DIAMETER)^2;     
MinArea = fix(pi*(0.5*MIN_DIAMETER)^2);     
[B,L] = bwboundaries(RESULT_ERODE,'noholes');
stats = regionprops(L,'Area','PixelIdxList','EquivDiameter');
NUCLEI_CLUMPED = RESULT_ERODE;
NUCLEI_CLUMPED(:,:) = 0;
NUCLEI_SINGLED= RESULT_ERODE;

for i=1:length(B)
    if stats(i).Area>MaxArea
        NUCLEI_CLUMPED(stats(i).PixelIdxList) = 1;
        NUCLEI_SINGLED(stats(i).PixelIdxList) = 0;
    end
end
NUCLEI_CLUMPED = ~NUCLEI_CLUMPED;
NUCLEI_CLUMPED = bwareaopen(NUCLEI_CLUMPED,MinArea);
NUCLEI_CLUMPED = ~NUCLEI_CLUMPED;
imgDist = bwdist(~NUCLEI_CLUMPED);

h = fspecial('disk', fix(0.5*MIN_DIAMETER));
imgDist = filter2(h,imgDist);
imgDist = -imgDist;
imgDist(~NUCLEI_CLUMPED) = -Inf;
Overlaid=watershed(imgDist);
WatershedBoundaries = Overlaid > 0;
NUCLEI_SEPARATE = and(RESULT_ERODE,WatershedBoundaries);
NUCLEI = NUCLEI_SEPARATE;   
