% Read image
% function [BW MIN_DIAMETER MAX_DIAMETER n DIAMETER] =
% tumormask_holes_tumor(I,name);
function [BW,MIN_DIAMETER,MAX_DIAMETER,MEAN_DIAMETER] = tumormask_holes_tumor(I,mat,mat2);
% calcultes tumor mask of image
% input variable is analyzed three-channel image 
% output variable is tumor mask of image, 
%which is logical image

% % split channels of image
% [R G B] = ColorToGray(I);
% % we use only green channel to determine the grayscale image,
% % becuae cells contain the stains, which is green
% [len_x len_y len_z] = size(I);
% RED = I(:,:,1);
% GREEN = I(:,:,2);
% BLUE = I(:,:,3);
% array = [];
% array = BLUE(1:len_x*len_y);
% LENGTH = length(array);
% X = zeros(LENGTH, 6);
% X_ = zeros(LENGTH, 6);
% 
% array(1:LENGTH)= array;
% X(:,1) = array+1; % intensity in blue channel
% array(1:LENGTH)= GREEN(1:len_x*len_y);
% X(:,2) = array+1; % intensity in green channel
% X(:,3) = X(:,1)./X(:,2);
% X(:,4) = X(:,2)./X(:,1);
% X(:,5) = 1./X(:,1);
% X(:,6) = 1./X(:,2);
% 
% MEAN = mean(X);
% STD = std(X);
% for j=1:6
%     X_(:,j) = (X(:,j) - MEAN(j))/STD(j);
% end
% 
% R = X_'*X_/(LENGTH-1);
% [A L] = eig(R);
% weight = diag(L)/sum(sum(L));
% Z = X_*A;
% MEAN2 = mean(Z);
% STD2 = std(Z);
% for j=1:6
%     Z_(:,j) = ((Z(:,j) - MEAN2(j))/STD2(j)+3)/6;
% end
% mat = vec2mat(Z_(:,6),	len_x);
% mat2 = vec2mat(Z_(:,5),	len_x);

threshold = graythresh(mat);
BW = im2bw(mat,threshold);

BW = ~BW;
[B,L] = bwboundaries(~BW,'noholes');
stats = regionprops(L,mat,'Area','PixelIdxList','EquivDiameter','PixelValues','MeanIntensity');
DIAMETER = [];
for j=1:length(B)
    DIAMETER(j) = stats(j).EquivDiameter;  
    MEAN(j) = stats(j).MeanIntensity; 
end
[par,resnorm,DISTANCE_POCKETS,H2] = lsestimation(DIAMETER);
f = mixpdf(par,DISTANCE_POCKETS);
index =find(DISTANCE_POCKETS>par(2));
[MIN_F, MIN_DIAMETER_NUMBER] = min(f(1:(index(1)-1)));
MIN_DIAMETER = DISTANCE_POCKETS(MIN_DIAMETER_NUMBER);
MAX_DIAMETER = par(2)+2*par(3);
MEAN_DIAMETER = par(2);

MAX_AREA = fix(0.25*pi*(MAX_DIAMETER+2*par(3))^2);
MIN_AREA = fix(0.25*pi*(MIN_DIAMETER)^2);
se = strel('disk',fix(0.5*MIN_DIAMETER));
BW = imdilate(BW,se);
BW_2 = ~BW;
BW_2 = bwareaopen(BW_2,MIN_AREA);
BW_3 = bwareaopen(BW_2,MAX_AREA);
BW = ~BW_3;
BW = bwareaopen(BW,MAX_AREA)';