function varargout = DCM(varargin)
% DCM MATLAB code for DCM.fig
%      DCM, by itself, creates a new DCM or raises the existing
%      singleton*.
%
%      H = DCM returns the handle to a new DCM or the handle to
%      the existing singleton*.
%
%      DCM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DCM.M with the given input arguments.
%
%      DCM('Property','Value',...) creates a new DCM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before DCM_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to DCM_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help DCM

% Last Modified by GUIDE v2.5 08-Dec-2014 11:53:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @DCM_OpeningFcn, ...
                   'gui_OutputFcn',  @DCM_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before DCM is made visible.
function DCM_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to DCM (see VARARGIN)

% Choose default command line output for DCM
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes DCM wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = DCM_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in PB_Load.
function PB_Load_Callback(hObject, eventdata, handles)
% hObject    handle to PB_Load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global imageFilePath; % Filepath and filename
global imageFileName; % Filepath and filename

 if imageFilePath == 0
    imageFilePath='';
 end;

 [imageFileName,imageFilePath,FilterIndex]=uigetfile({'*.jpg;*.tif;*.tiff;*.png;*.gif;*.czi;*.zvi;*.lsm','All Image Files';...
          '*.*','All Files' },'Load noisy image...', imageFilePath);
      
 if imageFileName == 0
   return;
 end

 fullPath = [imageFilePath imageFileName];
 
 handles.IMAGE = im2double(imread(fullPath));
 axes(handles.SegmentationAxes); % Switches focus to this axes object.
 imshow(handles.IMAGE); 
 guidata(gcbo,handles);

% --- Executes on button press in PB_ProcessImage.
function PB_ProcessImage_Callback(hObject, eventdata, handles)
% hObject    handle to PB_ProcessImage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
addpath('..\CodeSegmentation');

[mat, mat2, Z] = LisitsaPCA(handles.IMAGE);    
[handles.TUMOR handles.MinDiameter handles.MaxDiameter MEAN_DIAMETER] = tumormask_holes_tumor(handles.IMAGE,mat,mat2);
[RESULT_ERODE,MIN_DIAMETER,MAX_DIAMETER,MEAN_DIAMETER] = ImageSegmentationPCA(handles.IMAGE(:,:,3),handles.TUMOR,handles.MinDiameter,handles.MaxDiameter,MEAN_DIAMETER); 
NUCLEI_2 = separate2(RESULT_ERODE,handles.IMAGE,MIN_DIAMETER,MEAN_DIAMETER);
NUCLEI_2 = imfill(NUCLEI_2,'holes');
MinArea = fix(pi*(0.5*MIN_DIAMETER)^2);  
NUCLEI_2 = bwareaopen(NUCLEI_2,MinArea);

[RESULT_ERODE_GOOD,MIN_DIAMETER_GOOD,MAX_DIAMETER_GOOD,MEAN_DIAMETER_GOOD] = ImageSegmentationPCA(handles.IMAGE(:,:,3),~handles.TUMOR,handles.MinDiameter,handles.MaxDiameter,MEAN_DIAMETER); 
NUCLEI_2_GOOD = separate2(RESULT_ERODE_GOOD,handles.IMAGE,MIN_DIAMETER,MEAN_DIAMETER);
NUCLEI_2_GOOD = imfill(NUCLEI_2_GOOD,'holes');
MinArea = fix(pi*(0.5*MIN_DIAMETER)^2);  
NUCLEI_2_GOOD = bwareaopen(NUCLEI_2_GOOD,MinArea);

handles.NucleiMask = or(NUCLEI_2,NUCLEI_2_GOOD);

guidata(gcbo,handles);
axes(handles.SegmentationAxes);
[handles.B, handles.L] = bwboundaries(handles.NucleiMask);
handles.stats = regionprops(handles.L,'PixelList');

[handles.Data, handles.type] = GetData(handles.NucleiMask,handles.IMAGE,handles.TUMOR);
handles.UserType = handles.type;



MEAN = mean(handles.Data);
STD = std(handles.Data);
[len_x len_y len_z] = size(handles.Data);
for i=1:(len_y)
    NORM_DATA(:,i)=(handles.Data(:,i)-MEAN(i))/STD(i);
end

handles.NormData = NORM_DATA;

[handles.Z,ContribLamb] = PCAFunction(handles.NormData);


handles.MyImshow = MyImshow(handles.IMAGE,handles.B,handles.type);
set(gcf,'WindowButtonMotionFcn', {@mouseMove,handles});
set(gcf,'WindowButtonDownFcn', {@mouseClick,handles});

cname = [{'XM'};{'YM'};{'Angle'};{'Eccentricity'};{'FilledArea'};{'Solidity'};{'MEAN_RED'};{'MEAN_BLUE'};{'STD_RED'};{'MEDIAN_RED'};{'MEAN_GREEN'};{'PRE-TYPE'};{'USER-TYPE'};{'TYPE'}];
columnformat = {'numeric','numeric','numeric','numeric','numeric','numeric','numeric','numeric','numeric','numeric','numeric','numeric', 'numeric'};
columneditable = [false false false false false false false false false false false false true false];

DATA_HTML = mat2html([handles.Data handles.type' handles.UserType' 0*handles.type'],handles.type);
set(handles.NucleiTable,'Data',DATA_HTML,'ColumnName',cname,'ColumnFormat', columnformat, 'ColumnEditable', columneditable,'Visible','on'); 

axes(handles.DMAxes);
gscatter(handles.Z(:,10),handles.Z(:,11),handles.type,'mcrgbwk');
set(handles.RBPCA,'Value',1);
set(handles.RBProfiles,'Value',0);

guidata(gcbo,handles);




% --- Executes on button press in PB_SetTeachers.
function PB_SetTeachers_Callback(hObject, eventdata, handles)
% hObject    handle to PB_SetTeachers (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in RB_ClassA.
function RB_ClassA_Callback(hObject, eventdata, handles)
% hObject    handle to RB_ClassA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of RB_ClassA


% --- Executes on button press in RB_ClassB.
function RB_ClassB_Callback(hObject, eventdata, handles)
% hObject    handle to RB_ClassB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of RB_ClassB


% --- Executes on button press in RB_Image.
function RB_Image_Callback(hObject, eventdata, handles)
% hObject    handle to RB_Image (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of RB_Image
set(handles.RB_Image,'Value',1);
set(handles.RB_Tumor,'Value',0);
set(handles.RB_Nuclei,'Value',0);
set(handles.Edges,'Value',0);

axes(handles.SegmentationAxes);
imshow(handles.IMAGE);

% --- Executes on button press in RB_Tumor.
function RB_Tumor_Callback(hObject, eventdata, handles)
% hObject    handle to RB_Tumor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of RB_Tumor
set(handles.RB_Image,'Value',0);
set(handles.RB_Tumor,'Value',1);
set(handles.RB_Nuclei,'Value',0);
set(handles.Edges,'Value',0);

axes(handles.SegmentationAxes);
imshow(handles.TUMOR);

% --- Executes on button press in RB_Nuclei.
function RB_Nuclei_Callback(hObject, eventdata, handles)
% hObject    handle to RB_Nuclei (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of RB_Nuclei
set(handles.RB_Image,'Value',0);
set(handles.RB_Tumor,'Value',0);
set(handles.RB_Nuclei,'Value',1);
set(handles.Edges,'Value',0);

axes(handles.SegmentationAxes);
imshow(handles.NucleiMask);


% --- Executes when selected cell(s) is changed in NucleiTable.
function NucleiTable_CellSelectionCallback(hObject, eventdata, handles)
% hObject    handle to NucleiTable (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) currently selecteds
% handles    structure with handles and user data (see GUIDATA)
Indices = eventdata.Indices;
Line = Indices(:,1);
if ~isempty(Line)
    axes(handles.SegmentationAxes);
    DATA = get(handles.NucleiTable,'Data');
    USER_TYPE_CELL = (DATA(:,13));
    SIZE = size(USER_TYPE_CELL);
    for i=1:SIZE(1)
        str = cell2mat(USER_TYPE_CELL(i));
        str2num(str(31));
        TYPE(i) = str2num(str(31));
    end
    set(handles.SegmentationAxes);
    handles.MyImshow = MyImshow(handles.IMAGE,handles.B,TYPE);
    hold on
    for i=1:length(Line)
        boundary = handles.B{Line(i)};
        plot(boundary(:,2),boundary(:,1),'LineWidth',2,'Color','white');
    end
    hold off
    set(handles.MyImshow,'ButtonDownFcn',@ImageClickCallback);
    
    Pixels = handles.stats(Line(length(Line))).PixelList;
 
    cname = [{'X'};{'Y'};{'Red'};{'Green'};{'Blue'};];
    columnformat = {'numeric','numeric','numeric','numeric','numeric'};
    columneditable = [false false false false false];

    red = [];
    green = [];
    blue = [];
    for i=1:length(Pixels)
        red = [red handles.IMAGE(Pixels(i,1),Pixels(i,2),1)]; 
        green = [green handles.IMAGE(Pixels(i,1),Pixels(i,2),2)]; 
        blue = [blue handles.IMAGE(Pixels(i,1),Pixels(i,2),3)]; 
    end
    set(handles.PixelLevelTable,'Data',[Pixels(:,1), Pixels(:,2),red',green',blue'],'ColumnName',cname,'ColumnFormat', columnformat, 'ColumnEditable', columneditable,'Visible','on');
    axes(handles.SegmentationAxes);
end

% --- Executes on button press in PBLDA.
function PBLDA_Callback(hObject, eventdata, handles)
% hObject    handle to PBLDA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
DATA = get(handles.NucleiTable,'Data');

USER_TYPE_CELL = (DATA(:,13));
SIZE = size(USER_TYPE_CELL);
UserType = zeros(1,SIZE(1));
for i=1:SIZE(1)
    STR = cell2mat(USER_TYPE_CELL(i));
    UserType(i) = str2num(STR(31));
end
index1 = find(UserType==3);
index2 = find(UserType==4);
index3 = find(UserType==3);
index4 = find(UserType==4);
if (~isempty(index3))&(~isempty(index4))
    NormData = handles.NormData(:,:);
    Data1 = NormData(index1(:),:);
    Data2 = NormData(index2(:),:);
    TeacherData = [Data1;Data2];
    TeacherType = [ones(1,length(index1)),2*ones(1,length(index2))];
    handles.type = classify(NormData,TeacherData,TeacherType,'linear')';
    axes(handles.SegmentationAxes);
    handles.MyImshow = MyImshow(handles.IMAGE,handles.B,handles.type);
    set(handles.MyImshow,'ButtonDownFcn',@ImageClickCallback);
    
    DATA_HTML = mat2html([handles.Data handles.type' handles.type' handles.type'],handles.type);
    handles.UserType = handles.type;
    set(handles.NucleiTable,'Data',DATA_HTML);
    
    axes(handles.DMAxes);
    gscatter(handles.Z(:,10),handles.Z(:,11),handles.type,'cmrgbwk');
    set(handles.RBPCA,'Value',1);
    set(handles.RBProfiles,'Value',0);
else
    'The teacher data is not defined correctly!'
end
guidata(gcbo,handles);


% --- Executes on button press in BtnKMeans.
function BtnKMeans_Callback(hObject, eventdata, handles)
% hObject    handle to BtnKMeans (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.type = kmeans(handles.NormData,2,'distance','cityblock')';

axes(handles.SegmentationAxes)
handles.MyImshow = MyImshow(handles.IMAGE,handles.B,handles.type);
% set(gcf,'WindowButtonMotionFcn', {@mouseMove,handles});

DATA_HTML = mat2html([handles.Data handles.type' handles.type' handles.type'],handles.type);
handles.UserType = handles.type;
set(handles.NucleiTable,'Data',DATA_HTML);

axes(handles.DMAxes);
gscatter(handles.Z(:,10),handles.Z(:,11),handles.type,'cmrgbwk');

set(handles.RBPCA,'Value',1);
set(handles.RBProfiles,'Value',0);
guidata(gcbo,handles);


% --- Executes on button press in RBPCA.
function RBPCA_Callback(hObject, eventdata, handles)
% hObject    handle to RBPCA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of RBPCA
DATA = get(handles.NucleiTable,'Data');
USER_TYPE_CELL = (DATA(:,13));
SIZE = size(USER_TYPE_CELL);
for i=1:SIZE(1)
    str = cell2mat(USER_TYPE_CELL(i));
    str2num(str(31));
    TYPE(i) = str2num(str(31));
end
axes(handles.DMAxes);
% gscatter(handles.Z(:,10),handles.Z(:,11),handles.type,'mcrgbwk');
gscatter(handles.Z(:,10),handles.Z(:,11),TYPE,'mcrgbwk');
set(handles.RBPCA,'Value',1);
set(handles.RBProfiles,'Value',0);

% --- Executes on button press in RBProfiles.
function RBProfiles_Callback(hObject, eventdata, handles)
% hObject    handle to RBProfiles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of RBProfiles
set(handles.RBPCA,'Value',0);
set(handles.RBProfiles,'Value',1);

DATA = get(handles.NucleiTable,'Data');
USER_TYPE_CELL = (DATA(:,13));
SIZE = size(USER_TYPE_CELL);
for i=1:SIZE(1)
    str = cell2mat(USER_TYPE_CELL(i));
    str2num(str(31));
    TYPE(i) = str2num(str(31));
end

indexes = find(handles.type==2);
MEAN_1 = mean(handles.NormData(TYPE==1,:));
MEAN_2 = mean(handles.NormData(TYPE~=1,:));

axes(handles.DMAxes);
plot(MEAN_1,'Color','magenta');
hold on 
plot(MEAN_2,'Color','cyan');
hold off

function ImageClickCallback (hObject, eventdata, ~)
   axesHandle  = get(hObject,'Parent');
   coordinates = get(axesHandle,'CurrentPoint'); 
   coordinates = coordinates(1,1:2);
   
   get(axesHandle,'CurrentPoint')


% --- Executes during object creation, after setting all properties.
function SegmentationAxes_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SegmentationAxes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate SegmentationAxes


% --- Executes on button press in Edges.
function Edges_Callback(hObject, eventdata, handles)
% hObject    handle to Edges (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Edges
DATA = get(handles.NucleiTable,'Data');
USER_TYPE_CELL = (DATA(:,13));
SIZE = size(USER_TYPE_CELL);
for i=1:SIZE(1)
    str = cell2mat(USER_TYPE_CELL(i));
    str2num(str(31));
    TYPE(i) = str2num(str(31));
end
set(handles.SegmentationAxes);
handles.MyImshow = MyImshow(handles.IMAGE,handles.B,TYPE);



% --- Executes when entered data in editable cell(s) in NucleiTable.
function NucleiTable_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to NucleiTable (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
DATA = get(handles.NucleiTable,'Data');
USER_TYPE_CELL = (DATA(:,13));
SIZE = size(USER_TYPE_CELL);
for i=1:SIZE(1)
    if length(str2num(cell2mat(USER_TYPE_CELL(i))))>0
        handles.UserType(i) = str2num(cell2mat(USER_TYPE_CELL(i)));
    end
end
guidata(gcbo,handles);

axes(handles.SegmentationAxes);
handles.MyImshow = MyImshow(handles.IMAGE,handles.B,handles.UserType);

% DATA_HTML = mat2html([handles.Data handles.type' handles.UserType' 0*handles.type'],handles.type);
DATA_HTML = mat2html([handles.Data handles.type' handles.UserType' 0*handles.type'], handles.UserType);
set(handles.NucleiTable,'Data',DATA_HTML);

set(handles.RB_Tumor,'Value',0);
set(handles.RB_Nuclei,'Value',0);
set(handles.RB_Image,'Value',0);
set(handles.Edges,'Value',1);


% --------------------------------------------------------------------
function NucleiTable_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to NucleiTable (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in PBDDA.
function PBDDA_Callback(hObject, eventdata, handles)
% hObject    handle to PBDDA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
DATA = get(handles.NucleiTable,'Data');

USER_TYPE_CELL = (DATA(:,13));
SIZE = size(USER_TYPE_CELL);
UserType = zeros(1,SIZE(1));
for i=1:SIZE(1)
    STR = cell2mat(USER_TYPE_CELL(i));
    UserType(i) = str2num(STR(31));
end
index1 = find(UserType==3);
index2 = find(UserType==4);
index3 = find(UserType==3);
index4 = find(UserType==4);
if (~isempty(index3))&(~isempty(index4))
    NormData = handles.NormData(:,:);
    Data1 = NormData(index1(:),:);
    Data2 = NormData(index2(:),:);
    TeacherData = [Data1;Data2];
    TeacherType = [ones(1,length(index1)),2*ones(1,length(index2))];
    handles.type = classify(NormData,TeacherData,TeacherType,'quadratic')';
    axes(handles.SegmentationAxes);
    handles.MyImshow = MyImshow(handles.IMAGE,handles.B,handles.type);
    set(handles.MyImshow,'ButtonDownFcn',@ImageClickCallback);
    
    DATA_HTML = mat2html([handles.Data handles.type' handles.type' handles.type'],handles.type);
    handles.UserType = handles.type;
    set(handles.NucleiTable,'Data',DATA_HTML);
    
    axes(handles.DMAxes);
    gscatter(handles.Z(:,10),handles.Z(:,11),handles.type,'cmrgbwk');
    set(handles.RBPCA,'Value',1);
    set(handles.RBProfiles,'Value',0);
else
    'The teacher data is not defined correctly!'
end
guidata(gcbo,handles);


% --- Executes on button press in PBNB.
function PBNB_Callback(hObject, eventdata, handles)
% hObject    handle to PBNB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
DATA = get(handles.NucleiTable,'Data');

USER_TYPE_CELL = (DATA(:,13));
SIZE = size(USER_TYPE_CELL);
UserType = zeros(1,SIZE(1));
for i=1:SIZE(1)
    STR = cell2mat(USER_TYPE_CELL(i));
    UserType(i) = str2num(STR(31));
end
index1 = find(UserType==3);
index2 = find(UserType==4);
index3 = find(UserType==3);
index4 = find(UserType==4);
if (~isempty(index3))&(~isempty(index4))
    NormData = handles.NormData(:,:);
    Data1 = NormData(index1(:),:);
    Data2 = NormData(index2(:),:);
    TeacherData = [Data1;Data2];
    TeacherType = [ones(1,length(index1)),2*ones(1,length(index2))];
    handles.type = classify(NormData,TeacherData,TeacherType,'diaglinear')';
    axes(handles.SegmentationAxes)
    handles.MyImshow = MyImshow(handles.IMAGE,handles.B,handles.type);
    set(handles.MyImshow,'ButtonDownFcn',{@ImageClickCallback,handles});
    
    DATA_HTML = mat2html([handles.Data handles.type' handles.type' handles.type'],handles.type);
    handles.UserType = handles.type;
    set(handles.NucleiTable,'Data',DATA_HTML);
    
    axes(handles.DMAxes);
    gscatter(handles.Z(:,10),handles.Z(:,11),handles.type,'cmrgbwk');
    set(handles.RBPCA,'Value',1);
    set(handles.RBProfiles,'Value',0);
else
    'The teacher data is not defined correctly!'
end
guidata(gcbo,handles);

function [] = mouseMove(varargin)
% handles.SegmentationAxes
handles = varargin{3};
Position = get(handles.SegmentationAxes,'Position');

coordinates = get(handles.SegmentationAxes,'CurrentPoint'); 
coordinates = coordinates(1,1:2);

L = bwlabel(handles.NucleiMask, 8);

% get user type 
DATA = get(handles.NucleiTable,'Data');
USER_TYPE_CELL = (DATA(:,13));
SIZE = size(USER_TYPE_CELL);
for i=1:SIZE(1)
    str = cell2mat(USER_TYPE_CELL(i));
    str2num(str(31));
    TYPE(i) = str2num(str(31));
end

X = fix(coordinates(1,1));
Y = fix(coordinates(1,2));
[HEIGHT WIDTH]=size(L);
SIZE = size(handles.NucleiMask);
L = bwlabel(handles.NucleiMask, 8);
DATA = [];
DATA = handles.Data;
if (X>0)&(X<HEIGHT)&(Y>0)&(Y<WIDTH)
    NUMBER = L(Y,X);
    if NUMBER>0
       String = [];
       cname = [{'XM'};{'YM'};{'Angle'};{'Eccentricity'};{'FilledArea'};{'Solidity'};{'MEAN_RED'};{'MEAN_BLUE'};{'STD_RED'};{'MEDIAN_RED'};{'MEAN_GREEN'};{'PRE-TYPE'};{'USER-TYPE'};{'TYPE'}];
       for i=1:(length(cname)-3)
           String = [String, '; ' cname{i,:} ': ' num2str(DATA(NUMBER,i))];
       end
       set(handles.TextPosition,'String',['Number ' num2str(NUMBER) String]);
    else
        set(handles.TextPosition,'String','Choose any cell');
    end
end



function [] = mouseClick(varargin)
'Is it here'
handles = varargin{3};
Position = get(handles.SegmentationAxes,'Position');

coordinates = get(handles.SegmentationAxes,'CurrentPoint'); 
coordinates = coordinates(1,1:2)
width = 90.4; height = 34.7;
x_start = 139.8; y_start = 5.23;
x_width = x_start+width; y_width = y_start+height;
POSITION = get(handles.SegmentationAxes,'OuterPosition')
% if (coordinates(1,1)>x_start)&(coordinates(1,1)<x_width)&(coordinates(1,2)>y_start)&(coordinates(1,2)<y_width)
if (coordinates(1,1)>0)&(coordinates(1,2)>0)
    
    L = bwlabel(handles.NucleiMask, 8);
    
    % get user type 
    DATA = get(handles.NucleiTable,'Data');
    USER_TYPE_CELL = (DATA(:,13));
    SIZE = size(USER_TYPE_CELL);
    for i=1:SIZE(1)
        str = cell2mat(USER_TYPE_CELL(i));
        str2num(str(31));
        TYPE(i) = str2num(str(31));
    end
    
    X = fix(coordinates(1,1));
    Y = fix(coordinates(1,2));
    [HEIGHT WIDTH]=size(L);
    if (X>0)&(X<HEIGHT)&(Y>0)&(Y<WIDTH)
        NUMBER = L(Y,X);
        if NUMBER>0
            TYPE(NUMBER) = 6;
        end
    end
    
    set(handles.SegmentationAxes);
    handles.MyImshow = MyImshow(handles.IMAGE,handles.B,TYPE);
    handles.MyImshow
    guidata(gcbo,handles);
end


% --- Executes on mouse press over axes background.
function SegmentationAxes_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to SegmentationAxes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over RBProfiles.
function RBProfiles_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to RBProfiles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in TeacherA_PB.
function TeacherA_PB_Callback(hObject, eventdata, handles)
% hObject    handle to TeacherA_PB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.TeacherB_PB,'Value',0);
set(handles.TeacherB_PB,'Value',0);
set(handles.TeacherB_PB,'Value',0);
set(handles.Edges,'Value',1);

axes(handles.SegmentationAxes);
handles.MyImshow = MyImshow(handles.IMAGE,handles.B,handles.type);

% --- Executes on button press in TeacherB_PB.
function TeacherB_PB_Callback(hObject, eventdata, handles)
% hObject    handle to TeacherB_PB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in ClassA_PB.
function ClassA_PB_Callback(hObject, eventdata, handles)
% hObject    handle to ClassA_PB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in ClassB_PB.
function ClassB_PB_Callback(hObject, eventdata, handles)
% hObject    handle to ClassB_PB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in SaveTumButton.
function SaveTumButton_Callback(hObject, eventdata, handles)
% hObject    handle to SaveTumButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FileName,PathName,FilterIndex] = uiputfile( {'*.tiff';'*.*'});
imwrite(handles.TUMOR,[PathName FileName '.tiff']);

% --- Executes on button press in SaveTableButton.
function SaveTableButton_Callback(hObject, eventdata, handles)
% hObject    handle to SaveTableButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
DATA = get(handles.NucleiTable,'Data');
[len_x len_y] = size(DATA);
TITLE = [{'XM'};{'YM'};{'Angle'};{'Eccentricity'};{'FilledArea'};{'Solidity'};{'MEAN_RED'};{'MEAN_BLUE'};{'STD_RED'};{'MEDIAN_RED'};{'MEAN_GREEN'};{'PRE-TYPE'};{'USER-TYPE'};{'TYPE'}];
DATA3 = [TITLE'];
str1 = '<html><body bgcolor="#FF00FF">';
str2 = '</body></html>';
for i=1:len_x
    for j=1:len_y
        START = findstr(cell2mat(DATA(i,j)),str1)+length(str1)
        FINISH = findstr(cell2mat(DATA(i,j)),str2)-1
        str = [];
        str = cell2mat(DATA(i,j));
        DATA3(i+1,j) = {str(START:FINISH)};
    end
end
% DATA3 = [TITLE']      
[FileName,PathName,FilterIndex] = uiputfile( {'*.xls';'*.*'});
xlswrite([PathName FileName '.xls'],DATA3);

% --- Executes on button press in SaveEdgesButton.
function SaveEdgesButton_Callback(hObject, eventdata, handles)
% hObject    handle to SaveEdgesButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FileName,PathName,FilterIndex] = uiputfile( {'*.tiff';'*.*'});
IMAGE2 = handles.IMAGE;
B = handles.B;
for i=1:length(B)
    boubdary = [];
    boubdary = B{i};
    length(boubdary)
    for j=1:length(boubdary)
        IMAGE2(boubdary(j,1),boubdary(j,2),1) =   255;
        IMAGE2(boubdary(j,1),boubdary(j,2),2) =   0;
        IMAGE2(boubdary(j,1),boubdary(j,2),3) =   255;
    end
end
imwrite(IMAGE2,[PathName FileName '.tiff']);


% --- Executes on button press in SaveNucleiButton.
function SaveNucleiButton_Callback(hObject, eventdata, handles)
% hObject    handle to SaveNucleiButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FileName,PathName,FilterIndex] = uiputfile( {'*.tiff';'*.*'});
imwrite(handles.NucleiMask,[PathName FileName '.tiff']);
