function [DATA,PRE_TYPE] = GetData(NUCLEI,I,TUMOR)
BLUE = I(:,:,3);
GREEN = I(:,:,2);
RED = I(:,:,1);

[B L] = bwboundaries(NUCLEI);
stats = regionprops(L,'FilledArea','Centroid','Orientation','Eccentricity','Solidity','PixelIdxList');
for i=1:length(B)
    pixels = [];
    red = [];
    blue = [];
    green = [];
    pixels = stats(i).PixelIdxList;
    red = RED(pixels);
    green = GREEN(pixels);
    blue = BLUE(pixels);
    DATA(i,1:2) = stats(i).Centroid;
    DATA(i,3) = stats(i).Orientation;
    DATA(i,4) = stats(i).Eccentricity;
    DATA(i,5) = stats(i).FilledArea;
    DATA(i,6) = stats(i).Solidity;
    DATA(i,7) = mean(red);
    DATA(i,8) = mean(blue);
    DATA(i,9) = std(red);
    DATA(i,10) = median(red);
    DATA(i,11) = mean(green);
    PRE_TYPE(i) = fix(sum(TUMOR(pixels(:)))/length(pixels))+1; 
end
